# version d'origine
def binaire(nombre):
    """ prend un entier positif et renvoie
        le texte correspondant à la
        même valeur mais en binaire."""
    nb_binaire = ""
    while nombre > 0:
        nb_binaire = str(nombre%2) + nb_binaire
        nombre = nombre // 2
    return nb_binaire

# version corrigée
def binaire(nombre):
    """ prend un entier positif et renvoie
        le texte correspondant à la
        même valeur mais en binaire."""
    nb_binaire = ""
    while nombre > 0:
        nb_binaire = str(nombre%2) + nb_binaire
        nombre = nombre // 2
    return nb_binaire

assert binaire(2) == "10"
assert binaire(200) == "11001000"

###########################################
# version d'origine
def complement_a_un(nb_bin):
    """ prend un texte correspondant
        a un nombre binaire et renvoie
        un texte correspondant au
        complément à 1."""
    compl = ""
    for bit in nb_bin:
        if bit == "1":
            compl = compl + "0"
        else:
            compl = compl + "1"
    return compl

# version corrigée
def complement_a_un(nb_bin):
    """ prend un texte correspondant
        a un nombre binaire et renvoie
        un texte correspondant au
        complément à 1."""
    compl = ""
    for bit in nb_bin:
        if bit == "1":
            compl = compl + "0"
        else:
            compl = compl + "1"
    return compl

assert complement_a_un("111") == "000"
assert complement_a_un("01101") == "10010"

##############################################
# version d'origine
def nb_elements(liste):
    """ prend une liste et renvoie
        un entier correspondant au nombre
        d'éléments qu'elle contient."""
    compteur = 0
    for val in liste:
        compteur = compteur + 1
    return compteur

# version corrigée
def nb_elements(liste):
    """ prend une liste et renvoie
        un entier correspondant au nombre
        d'éléments qu'elle contient."""
    compteur = 0
    for val in liste:
        compteur = compteur + 1
    return compteur

assert nb_elements([4, 1, 6]) == 3
assert nb_elements(["chien", "chat", "truite", "ours"]) == 4

##############################################
# version d'origine
def maximum(liste):
    """ prend une liste non vide d'entiers
        et renvoie la plus grande
        valeur qu'elle contient."""
    maxi = 0
    for val in liste:
        if val > maxi:
            maxi = val
    return maxi

# version corrigée
def maximum(liste):
    """ prend une liste non vide d'entiers
        et renvoie la plus grande
        valeur qu'elle contient."""
    maxi = 0
    for val in liste:
        if val > maxi:
            maxi = val
    return maxi

assert maximum([9]) == 9
assert maximum([1, 2, 3]) == 3
assert maximum([7, -9, 2, -1]) == 7

##############################################
# version d'origine
def position_minimum(liste):
    """ prend une liste non vide d'entiers
        et renvoie l'indice du minimum."""
    mini = liste[0]
    for i in range(len(liste)):
        if liste[i] < mini:
            mini = liste[i]
            position = i
    return position

# version corrigée
def position_minimum(liste):
    """ prend une liste non vide d'entiers
        et renvoie l'indice du minimum."""
    mini = liste[0]
    for i in range(len(liste)):
        if liste[i] < mini:
            mini = liste[i]
            position = i
    return position

assert position_minimum([9, 2, 4]) == 1
assert position_minimum([1, 3, 7, 0]) == 3

##############################################
# version d'origine
def identiques(liste1, liste2):
    """ prend deux listes et renvoie
        un booléen indiquant si les
        deux listes sont identiques ou pas.
        Identiques veut dire mêmes éléments,
        dans le même ordre."""
    for i in range(len(liste1)):
        if liste1[i] != liste2[i]:
            return False
        else:
            return True
        
# version corrigée
def identiques(liste1, liste2):
    """ prend deux listes et renvoie
        un booléen indiquant si les
        deux listes sont identiques ou pas.
        Identiques veut dire mêmes éléments,
        dans le même ordre."""
    for i in range(len(liste1)):
        if liste1[i] != liste2[i]:
            return False
        else:
            return True

assert identiques([1, 2, 3], [1, 2, 3])
assert not identiques([6, 4], [4, 6])
assert not identiques([3, 1], [4, 2, 1])

##############################################
# version d'origine
def nb_occurrences(liste):
    """ prend une liste et renvoie
        un dictionnaire associant à chaque
        élément différent de la liste le
        nombre de fois qu'il y apparaît."""
    compteurs = dict()
    for val in liste:
        if val in compteurs:
            compteurs[val] = 1
        else:
            compteurs[val] = 1
    return compteurs

# version corrigée
def nb_occurrences(liste):
    """ prend une liste et renvoie
        un dictionnaire associant à chaque
        élément différent de la liste le
        nombre de fois qu'il y apparaît."""
    compteurs = dict()
    for val in liste:
        if val in compteurs:
            compteurs[val] = 1
        else:
            compteurs[val] = 1
    return compteurs

assert nb_occurrences([5, 1, 3, 2]) == {1: 1, 2: 1, 3: 1, 5: 1}
assert nb_occurrences(["chat", "chien"]) == {"chat": 1, "chien": 1}